package com.zt.plat.module.qms.resource.device.service;

import java.text.ParseException;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.*;

import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.module.qms.resource.device.controller.vo.*;
import jakarta.validation.*;
import com.zt.plat.module.qms.resource.device.dal.dataobject.DeviceMaintainDO;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 设备-点检、保养记录 Service 接口
 *
 * @author 后台管理-1
 */
public interface DeviceMaintainService {

    CommonResult<DeviceMaintainDO> saveMaintainVo(DeviceMaintainVO vo);

    CommonResult<DeviceMaintainVO> createOrGet(Long deviceId, String date, String dataType);

    CommonResult<DeviceMaintainVO> create(Long deviceId, LocalDateTime lastDate, String dataType);

    PageResult<DeviceInfomationMaintainVO> queryPageListWithCount(DeviceMaintainPageReqVO pageReqVO);

    CommonResult<DeviceMaintainVO> getMaintainDetail(Long id);

    CommonResult<DeviceMaintainDO> getLastData(Long deviceId, String dataType, String date);


    /**
     * 创建设备-点检、保养记录
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    DeviceMaintainRespVO createDeviceMaintain(@Valid DeviceMaintainSaveReqVO createReqVO);

    /**
     * 更新设备-点检、保养记录
     *
     * @param updateReqVO 更新信息
     */
    void updateDeviceMaintain(@Valid DeviceMaintainSaveReqVO updateReqVO);

    /**
     * 删除设备-点检、保养记录
     *
     * @param id 编号
     */
    void deleteDeviceMaintain(Long id);

    /**
    * 批量删除设备-点检、保养记录
    *
    * @param ids 编号
    */
    void deleteDeviceMaintainListByIds(List<Long> ids);

    /**
     * 获得设备-点检、保养记录
     *
     * @param id 编号
     * @return 设备-点检、保养记录
     */
    DeviceMaintainDO getDeviceMaintain(Long id);

    /**
     * 获得设备-点检、保养记录分页
     *
     * @param pageReqVO 分页查询
     * @return 设备-点检、保养记录分页
     */
    PageResult<DeviceMaintainDO> getDeviceMaintainPage(DeviceMaintainPageReqVO pageReqVO);

}